<?php

include 'config/config.php';

function Filtering($aColumns, $iColumnCount, $input, $db)
{
    if ( isset($input['sSearch']) && $input['sSearch'] != "" ) {
        $aFilteringRules = array();
        for ( $i=0 ; $i<$iColumnCount ; $i++ ) {
            if ( isset($input['bSearchable_'.$i]) && $input['bSearchable_'.$i] == 'true' ) {
                $aFilteringRules[] = $aColumns[$i]." LIKE '%".$db->real_escape_string( $input['sSearch'] )."%'";
            }
        }

        if (!empty($aFilteringRules)) {
            $aFilteringRules = array('('.implode(" OR ", $aFilteringRules).')');
        }
    }
   
    // Individual column filtering
    for ( $i=0 ; $i<$iColumnCount ; $i++ ) {
        if ( isset($input['bSearchable_'.$i]) && $input['bSearchable_'.$i] == 'true' && $input['sSearch_'.$i] != '' ) {
            $aFilteringRules[] = $aColumns[$i]."  LIKE '%".$db->real_escape_string($input['sSearch_'.$i])."%'";
        }
    }
   
    if (!empty($aFilteringRules)) {

        $sWhere = " WHERE (YEAR(tbl_kuesioner_hasil.waktu) BETWEEN  '$tanggal_awal' AND '$tanggal_akhir' )  ".implode(" AND ", $aFilteringRules);
        //$sWhere = "WHERE ".implode(" AND ", $aFilteringRules);
        
    } else {

        $tanggal_awal   = @$_POST['tanggal_awal'];
        $tanggal_akhir  = @$_POST['tanggal_akhir'];

        $sWhere = " WHERE (YEAR(tbl_kuesioner_hasil.waktu) BETWEEN  '$tanggal_awal' AND '$tanggal_akhir' ) ";
        //$sWhere = "WHERE 1=1 ";
    }
    return $sWhere;
}

$tanggal_awal   = @$_POST['tanggal_awal'];
$tanggal_akhir  = @$_POST['tanggal_akhir'];

$db = new database();

// BUKA KONEKSI DATABASE
$mysqli = $db->buka_db();

mb_internal_encoding('UTF-8');
error_reporting(0);
extract($_REQUEST);

$aColumns = array('tbl_karyawan.id_karyawan', 'tbl_karyawan.nm_karyawan', 'tbl_karyawan.id_karyawan', 'tbl_karyawan.id_karyawan', 'tbl_karyawan.id_karyawan', 'tbl_karyawan.id_karyawan', 'tbl_karyawan.id_karyawan'); //Kolom Pada Tabel

// Input method (use $_GET, $_POST or $_REQUEST)
$input =& $_POST;

$iColumnCount = count($aColumns);

$sLimit = Paging($input);
$sOrder = Ordering($input, $aColumns);
$sWhere = Filtering($aColumns, $iColumnCount, $input, $mysqli);

$aQueryColumns = array();
foreach ($aColumns as $col) {
        if ($col != ' ') {
                $aQueryColumns[] = $col;
        }
}

$sQuery = "SELECT  SQL_CALC_FOUND_ROWS 
          tbl_karyawan.id_karyawan, 
          tbl_karyawan.nm_karyawan, 
          tbl_karyawan.id_divisi, 
          tbl_karyawan.id_pendidikan, 
          tbl_divisi.nm_divisi, 
          tbl_divisi.bbt_divisi, 
          tbl_pendidikan.pendidikan, 
          tbl_pendidikan.bbt_pendidikan, 
          tbl_kuesioner_hasil.hasil, 
          tbl_karyawan_maker.tgl_masuk, 
          (
            CASE WHEN tbl_karyawan_maker.tgl_resign = '0000-00-00' THEN CURDATE() ELSE tbl_karyawan_maker.tgl_resign END
          ) as tgl_keluar, 
          (
            FLOOR(
              PERIOD_DIFF(
                DATE_FORMAT(
                  CASE WHEN tbl_karyawan_maker.tgl_resign = '0000-00-00' THEN CURDATE() ELSE tbl_karyawan_maker.tgl_resign END, 
                  '%Y%m'
                ), 
                DATE_FORMAT(
                  tbl_karyawan_maker.tgl_masuk, '%Y%m'
                )
              )/ 12
            )
          ) as total_masa_kerja,
           (
                SELECT 
                    COUNT(*) as total_hadir 
                FROM 
                    tbl_karyawan_absensi 
                WHERE 
                    (YEAR(tbl_karyawan_absensi.tgl_absen) BETWEEN  '$tanggal_awal' AND '$tanggal_akhir' ) AND (tbl_karyawan_absensi.id_karyawan=tbl_karyawan.id_karyawan)
            ) as total_hadir
        FROM 
          tbl_karyawan 
          INNER JOIN tbl_divisi ON tbl_karyawan.id_divisi = tbl_divisi.id_divisi 
          INNER JOIN tbl_pendidikan ON tbl_karyawan.id_pendidikan = tbl_pendidikan.id_pendidikan 
          INNER JOIN tbl_kuesioner_hasil ON tbl_karyawan.id_karyawan = tbl_kuesioner_hasil.id_karyawan 
          INNER JOIN tbl_karyawan_maker ON tbl_karyawan.id_karyawan = tbl_karyawan_maker.id_karyawan 
        
            ".$sWhere." GROUP BY  tbl_karyawan.id_karyawan ".$sOrder.$sLimit;

$rResult = $mysqli->query( $sQuery ) or die($mysqli->error);

// Data set length after filtering
$sQuery = "SELECT FOUND_ROWS()";
$rResultFilterTotal = $mysqli->query($sQuery) or die($mysqli->error);
list($iFilteredTotal) = $rResultFilterTotal->fetch_row();

// Total data set length
$sQuery = "SELECT 
                COUNT(tbl_karyawan.id_karyawan) 
            FROM 
              tbl_karyawan 
              INNER JOIN tbl_divisi ON tbl_karyawan.id_divisi = tbl_divisi.id_divisi 
              INNER JOIN tbl_pendidikan ON tbl_karyawan.id_pendidikan = tbl_pendidikan.id_pendidikan 
              INNER JOIN tbl_kuesioner_hasil ON tbl_karyawan.id_karyawan = tbl_kuesioner_hasil.id_karyawan 
              INNER JOIN tbl_karyawan_maker ON tbl_karyawan.id_karyawan = tbl_karyawan_maker.id_karyawan 
            
                ".$sWhere." GROUP BY  tbl_karyawan.id_karyawan ".$sOrder.$sLimit;

$rResultTotal = $mysqli->query($sQuery) or die($mysqli->error);
list($iTotal) = $rResultTotal->fetch_row();

/**
* Output
*/
$output = array(
    "sEcho"                => intval($input['sEcho']),
    "iTotalRecords"        => $iTotal,
    "iTotalDisplayRecords" => $iFilteredTotal,
    "aaData"               => array(),
);

// Looping Data
while($aRow = $rResult->fetch_assoc()){
    $row = array();

    $row = array(
            $aRow['id_karyawan'], 
            $aRow['nm_karyawan'], 
            $aRow['nm_divisi'], 
            HitungJumlahAbsensi($aRow['total_hadir'], $tanggal_awal, $tanggal_akhir, $bobot =false),
            HitungMasaKerja($aRow['total_masa_kerja'], $bobot =false),
            $aRow['pendidikan'],
            HitungHasilKinerjaSetahun($aRow['hasil'], $bobot =false),
            );
    $output['aaData'][] = $row;
}


// TUTUP KONEKSI DATABASE
$db->tutup_db($mysqli);

// START SORT
$sortArray = array();

foreach($output['aaData'] as $person){
    foreach($person as $key=> $value){
        if(!isset($sortArray[$key])){
            $sortArray[$key] = array();
        }
        $sortArray[$key][] = $value;
    }
} 

$orderby = "0";

if(!empty($sortArray)){
    array_multisort($sortArray[$orderby], SORT_ASC, $output['aaData']); 
}
// END SORT


echo json_encode($output);
?>